// Prevents additional console window on Windows in release, DO NOT REMOVE!!
#![cfg_attr(not(debug_assertions), windows_subsystem = "windows")]

use std::collections::{HashMap, HashSet};
use std::{io::Cursor, path::PathBuf};
use std::io::Seek;
use self_update::cargo_crate_version;
use serde_json::{Map, Result, Value};
use serde::Serialize;
use serde::Deserialize;

mod ftp;
mod java;
mod prism;
mod system_dirs;
mod util;
mod modpack;

#[derive(Serialize, Deserialize)]
struct ModpackEntry{
    name: String,
    id: String
}

// Learn more about Tauri commands at https://tauri.app/v1/guides/features/command
#[tauri::command]
fn greet(name: &str) -> String {
    format!("Hello, {}! You've been greeted from Rust!", name)
}


fn main() {
    let status = self_update::backends::gitea::Update::configure().no_confirm(true).with_host("https://gitea.piwalker.net").repo_owner("piwalker").repo_name("FCLauncher").bin_name("FCLauncher").show_download_progress(true).current_version(cargo_crate_version!()).build().unwrap().update().unwrap();
    println!("update status: `{}`", status.version());
    println!("This is the updated version!");
    modpack::get_modpacks();
    //prism::install_prism();
    tauri::Builder::default()
        .invoke_handler(tauri::generate_handler![greet, modpack::get_modpacks, modpack::launch_modpack, prism::launch_prism, prism::install_prism])
        .run(tauri::generate_context!())
        .expect("error while running tauri application");
}
